Scriptname PlayWithAnimals extends SKI_ConfigBase  

;=====
; Properties
;=====
; Libraries
SexLabFramework Property SexLab Auto
sslSystemConfig Property SexLabConfig Auto
; Player
Actor Property PlayerRef Auto 

;=====
; Variables
;=====
int HotKey = 0
int Role = 0
String[] PlayerRole
Actor ActivatedActor

; ======
; Init
; ======
Event OnInit()
	Parent.OnInit()
	PlayerRole = new String[2]
	PlayerRole[0] = "Passive"
	PlayerRole[1] = "Active"
EndEvent

; ======
; Version control
; ======
Int Function GetVersion()
	Return 1
EndFunction

Event OnVersionUpdate(int a_version)
	If (a_version > CurrentVersion)
		OnConfigInit()
	EndIf
EndEvent

; ======
; Gives info on registered hotkey
; ======
String Function GetCustomControl(int keyCode)
	If (keyCode == HotKey)
		return "Play With Animals"
	Else		
		return ""
	EndIf
EndFunction

; ======
; Define pages
; ======
Event OnConfigInit()
	;
EndEvent

; ======
; Set up page
; ======
Event OnPageReset(string Page)
	int flags

	flags = OPTION_FLAG_NONE
	If(! SexLabConfig.AllowCreatures)
		flags = OPTION_FLAG_DISABLED
	EndIf

	If(Page == Pages[0])
		SetCursorFillMode(TOP_TO_BOTTOM)
		AddHeaderOption("PWA Setings")
		AddKeyMapOptionST("OIC_CreatureHotKey", "Creature Activation HotKey", HotKey, flags)
		AddMenuOptionST("OIC_PlayerRole", "Player Role", PlayerRole[Role], flags)
		SetCursorPosition(1)
		If(! SexLabConfig.AllowCreatures)
			Log("SexLab Creature Support not enabled")
			AddTextOptionST("OIC_NoCreatures", "SexLab Creature Support not enabled", "")
		EndIf
	EndIf
EndEvent

; ======
; Creature HotKey
; ======
State OIC_CreatureHotKey
Event OnKeyMapChangeST(int newKeyCode, string conflictControl, string conflictName)
	bool continue = true
	int NewCode = newKeyCode
	int OldCode = HotKey

	continue = VerifyHotKey(NewCode, conflictControl, conflictName)
	If (!continue)
		NewCode = 0
	EndIf
	if(NewCode == 15) || (NewCode == 1)
		NewCode = 0
	EndIf
	SetKeyMapOptionValueST(NewCode)
	SetHotKey(OldCode, NewCode)
EndEvent

Event OnHighlightST()
	SetInfoText("Hotkey for sex with creatures.")
EndEvent
EndState

; ======
; Role
; ======
State OIC_PlayerRole
Event OnMenuOpenST()
	SetMenuDialogStartIndex(Role)
	SetMenuDialogDefaultIndex(0)
	SetMenuDialogOptions(PlayerRole)
EndEvent

Event OnMenuAcceptST(int index)
	Role = index
	SetMenuOptionValueST(PlayerRole[Role])
EndEvent

Event OnHighlightST()
	SetInfoText("Select player role during creature sex.")
EndEvent
EndState

; ======
; No creature support - empty
; ======
State OIC_NoCreatures
Event OnSelectST()
	;
EndEvent
EndState

; ======
; Set hotkey
; ======
Function SetHotKey(int OldCode, int NewCode)
	If(OldCode != 0)
		UnregisterForKey(OldCode)
	EndIf
	HotKey = NewCode
	If(NewCode != 0) && (NewCode != 15) && (NewCode != 0)
		RegisterForCrosshairRef()
		RegisterForKey(NewCode)
	Else
		UnregisterForCrosshairRef()
	EndIf
EndFunction

; ======
; Check if hotkey already in use
; ======
Bool Function VerifyHotKey(int newKeyCode, string conflictControl, string conflictName)
	bool continue = true

	If(newKeyCode == 1) || (newKeyCode == 15)
		ShowMessage("New key cannot be Esc or Tab; clearing current key", false, "Ok")
		continue = false
	ElseIf (conflictControl != "")
		string msg
		if (conflictName != "")
			msg = "This key is already mapped to:\n\"" + conflictControl + "\"\n(" + conflictName + ")\n\nAre you sure you want to continue?"
		else
			msg = "This key is already mapped to:\n\"" + conflictControl + "\"\n\nAre you sure you want to continue?"
		endIf
		continue = ShowMessage(msg, true, "Yes", "No")
	EndIf
	Return continue
EndFunction

; ======
; New object under crosshair
; ======
Event OnCrosshairRefChange(ObjectReference ref)
	ActivatedActor = ref as Actor
EndEvent

; ======
; Hotkey pressed
; ======
Event OnKeyUp(Int KeyCode, Float HoldTime)
	Race CreatureRace

	; Ignore Esc and Tab, and key not ours
	If(KeyCode == 1) || (KeyCode == 15) || (KeyCode != HotKey)
		Return
	EndIf
	If(!ActivatedActor)
		Return
	EndIf
	If(! SexLab.IsValidActor(ActivatedActor))
		Return
	EndIf

	CreatureRace = ActivatedActor.GetLeveledActorBase().GetRace()
	If(CreatureRace.IsPlayable())
		Return
	EndIf

	If(SexLab.HasCreatureRaceAnimation(CreatureRace, 2, 2))
		If(Role == 0)
			; Player passive
			Log("Triggering sex with " + CreatureRace.GetName() + ", player passive")
			Fuck(PlayerRef, ActivatedActor, strInclude="Bestiality, Creature", CenterOn=PlayerRef)
		Else
			; Player active
			Log("Triggering sex with " + CreatureRace.GetName() + ", player active")
			Fuck(ActivatedActor, PlayerRef, strInclude="Bestiality, Creature", CenterOn=PlayerRef)
		EndIf
	Else
		Log("No anims for this creature: " + CreatureRace.GetName())
	EndIf
EndEvent

; =====
; Generic sex function
; =====
int function Fuck(Actor Actor1, Actor Actor2, string strInclude = "", ObjectReference CenterOn = none)
		sslBaseAnimation[] anims
		int result
		int count
		Actor[] SexActors = SexLab.MakeActorArray(Actor1, Actor2)

		count = sexActors.Length
		anims = SexLab.GetAnimationsByTags(count, strInclude, "Masturbation", false)
		; Claim a thread
		sslThreadModel Thread = SexLab.NewThread()
		if !Thread
			Log("SexLab.NewThread() failed.")
			return -1
		; Add actors list to thread
		elseIf !Thread.AddActors(SexActors)
			Log("Thread.AddActors(sexActors) Failed.")
			return -1
		endIf
		; Configure our thread with passed arguments
		Thread.SetAnimations(anims)
		Thread.DisableLeadIn(true)
		Thread.CenterOnObject(CenterOn)
		Thread.DisableBedUse(true)
		; Start the animation
		if Thread.StartThread()
			return Thread.tid
		endIf
		Log("Thread.StartThread() Failed")
		return -1
EndFunction

; =====
; Output messages
; =====
Function Log(string info)
	Debug.Trace("SLPWA: " + info)
	MiscUtil.PrintConsole("SLPWA: " + info)
EndFunction
